# qiskit_at_home

Repository containing the minimal requirements for using qiskit and the qiskit examples on 
your own laptop.

## Getting started

### Linux Ubuntu 22.04 (Jammy)

To get started, create a virtualenv:

```shell 
python -m venv /path/to/new/virtual/environment
source /path/to/new/virtual/environment/bin/activate
```

And install the requirements:

```shell
pip install -r requirements.txt
```

In case of errors, try to install the following packages via apt:

```
sudo apt-get install build-essential python3-dev
```

If this does not help, try to remove all qiskit-packages but `qiskit` and `qiskit-aer`. 
These two are sufficient for the basic usage of qiskit. See the file `requirements_minimal.txt` 
for an example. This could be installed via  

```
pip install -r requirements_minimal.txt 
```

## Use Jupyter Lab 

After activating the environment (see above), run 

```
cd    # switch to your home directory, see note below
jupyter-lab
```

This will start the Jupyter lab server and open the interface in your web browser.

> Important: The directory in which you run this command will be the base directory for 
Juypter and you will only be able to access files and folders that are children of it. 
Using the home directory via `cd` will give you most flexibility, but you can also start 
the jupyter server in any directory where you already have notebooks downloaded.

> You can find the extensive documentation about notebooks [here](https://jupyterlab.readthedocs.io/en/stable/user/notebook.html#notebook)

## Import a Notebook in Jupyter 

1. Download a Jupyter notebook file from iLearn (extension *.ipynb)
1. In the web interface, click the "Upload" icon and select your downloaded file 
    ![Import File](imgs/upload.png)
1. Done - you can now start the notebook on your own laptop

### Windows 

> Windows installation is possible. See [IBM Documentation](
https://docs.quantum.ibm.com/start/install)

On Windows, consider using [Conda](https://docs.conda.io/en/latest/) as Python distribution, 
it often works better than native Python.
